# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus.com.termlex.pathnexus.model.extension import Extension  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.string_type import StringType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.time_zone import TimeZone  # noqa: F401,E501


class InstantType(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]',
        'id': 'str',
        'extension': 'list[Extension]',
        'disallow_extensions': 'bool',
        'month': 'int',
        'millis': 'int',
        'year': 'int',
        'day': 'int',
        'hour': 'int',
        'minute': 'int',
        'second': 'int',
        'nanos': 'int',
        'precision': 'str',
        'time_zone': 'TimeZone',
        'value_as_calendar': 'datetime',
        'time_zone_zulu': 'bool',
        'today': 'bool',
        'value_as_string': 'str',
        'date_time': 'bool',
        'value': 'datetime',
        'primitive': 'bool',
        'empty': 'bool',
        'id_element': 'StringType',
        'extension_first_rep': 'Extension',
        'id_base': 'str',
        'resource': 'bool',
        'boolean_primitive': 'bool'
    }

    attribute_map = {
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost',
        'id': 'id',
        'extension': 'extension',
        'disallow_extensions': 'disallowExtensions',
        'month': 'month',
        'millis': 'millis',
        'year': 'year',
        'day': 'day',
        'hour': 'hour',
        'minute': 'minute',
        'second': 'second',
        'nanos': 'nanos',
        'precision': 'precision',
        'time_zone': 'timeZone',
        'value_as_calendar': 'valueAsCalendar',
        'time_zone_zulu': 'timeZoneZulu',
        'today': 'today',
        'value_as_string': 'valueAsString',
        'date_time': 'dateTime',
        'value': 'value',
        'primitive': 'primitive',
        'empty': 'empty',
        'id_element': 'idElement',
        'extension_first_rep': 'extensionFirstRep',
        'id_base': 'idBase',
        'resource': 'resource',
        'boolean_primitive': 'booleanPrimitive'
    }

    def __init__(self, format_comments_pre=None, format_comments_post=None, id=None, extension=None, disallow_extensions=None, month=None, millis=None, year=None, day=None, hour=None, minute=None, second=None, nanos=None, precision=None, time_zone=None, value_as_calendar=None, time_zone_zulu=None, today=None, value_as_string=None, date_time=None, value=None, primitive=None, empty=None, id_element=None, extension_first_rep=None, id_base=None, resource=None, boolean_primitive=None):  # noqa: E501
        """InstantType - a model defined in Swagger"""  # noqa: E501

        self._format_comments_pre = None
        self._format_comments_post = None
        self._id = None
        self._extension = None
        self._disallow_extensions = None
        self._month = None
        self._millis = None
        self._year = None
        self._day = None
        self._hour = None
        self._minute = None
        self._second = None
        self._nanos = None
        self._precision = None
        self._time_zone = None
        self._value_as_calendar = None
        self._time_zone_zulu = None
        self._today = None
        self._value_as_string = None
        self._date_time = None
        self._value = None
        self._primitive = None
        self._empty = None
        self._id_element = None
        self._extension_first_rep = None
        self._id_base = None
        self._resource = None
        self._boolean_primitive = None
        self.discriminator = None

        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post
        if id is not None:
            self.id = id
        if extension is not None:
            self.extension = extension
        if disallow_extensions is not None:
            self.disallow_extensions = disallow_extensions
        if month is not None:
            self.month = month
        if millis is not None:
            self.millis = millis
        if year is not None:
            self.year = year
        if day is not None:
            self.day = day
        if hour is not None:
            self.hour = hour
        if minute is not None:
            self.minute = minute
        if second is not None:
            self.second = second
        if nanos is not None:
            self.nanos = nanos
        if precision is not None:
            self.precision = precision
        if time_zone is not None:
            self.time_zone = time_zone
        if value_as_calendar is not None:
            self.value_as_calendar = value_as_calendar
        if time_zone_zulu is not None:
            self.time_zone_zulu = time_zone_zulu
        if today is not None:
            self.today = today
        if value_as_string is not None:
            self.value_as_string = value_as_string
        if date_time is not None:
            self.date_time = date_time
        if value is not None:
            self.value = value
        if primitive is not None:
            self.primitive = primitive
        if empty is not None:
            self.empty = empty
        if id_element is not None:
            self.id_element = id_element
        if extension_first_rep is not None:
            self.extension_first_rep = extension_first_rep
        if id_base is not None:
            self.id_base = id_base
        if resource is not None:
            self.resource = resource
        if boolean_primitive is not None:
            self.boolean_primitive = boolean_primitive

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this InstantType.  # noqa: E501


        :return: The format_comments_pre of this InstantType.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this InstantType.


        :param format_comments_pre: The format_comments_pre of this InstantType.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this InstantType.  # noqa: E501


        :return: The format_comments_post of this InstantType.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this InstantType.


        :param format_comments_post: The format_comments_post of this InstantType.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    @property
    def id(self):
        """Gets the id of this InstantType.  # noqa: E501


        :return: The id of this InstantType.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this InstantType.


        :param id: The id of this InstantType.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def extension(self):
        """Gets the extension of this InstantType.  # noqa: E501


        :return: The extension of this InstantType.  # noqa: E501
        :rtype: list[Extension]
        """
        return self._extension

    @extension.setter
    def extension(self, extension):
        """Sets the extension of this InstantType.


        :param extension: The extension of this InstantType.  # noqa: E501
        :type: list[Extension]
        """

        self._extension = extension

    @property
    def disallow_extensions(self):
        """Gets the disallow_extensions of this InstantType.  # noqa: E501


        :return: The disallow_extensions of this InstantType.  # noqa: E501
        :rtype: bool
        """
        return self._disallow_extensions

    @disallow_extensions.setter
    def disallow_extensions(self, disallow_extensions):
        """Sets the disallow_extensions of this InstantType.


        :param disallow_extensions: The disallow_extensions of this InstantType.  # noqa: E501
        :type: bool
        """

        self._disallow_extensions = disallow_extensions

    @property
    def month(self):
        """Gets the month of this InstantType.  # noqa: E501


        :return: The month of this InstantType.  # noqa: E501
        :rtype: int
        """
        return self._month

    @month.setter
    def month(self, month):
        """Sets the month of this InstantType.


        :param month: The month of this InstantType.  # noqa: E501
        :type: int
        """

        self._month = month

    @property
    def millis(self):
        """Gets the millis of this InstantType.  # noqa: E501


        :return: The millis of this InstantType.  # noqa: E501
        :rtype: int
        """
        return self._millis

    @millis.setter
    def millis(self, millis):
        """Sets the millis of this InstantType.


        :param millis: The millis of this InstantType.  # noqa: E501
        :type: int
        """

        self._millis = millis

    @property
    def year(self):
        """Gets the year of this InstantType.  # noqa: E501


        :return: The year of this InstantType.  # noqa: E501
        :rtype: int
        """
        return self._year

    @year.setter
    def year(self, year):
        """Sets the year of this InstantType.


        :param year: The year of this InstantType.  # noqa: E501
        :type: int
        """

        self._year = year

    @property
    def day(self):
        """Gets the day of this InstantType.  # noqa: E501


        :return: The day of this InstantType.  # noqa: E501
        :rtype: int
        """
        return self._day

    @day.setter
    def day(self, day):
        """Sets the day of this InstantType.


        :param day: The day of this InstantType.  # noqa: E501
        :type: int
        """

        self._day = day

    @property
    def hour(self):
        """Gets the hour of this InstantType.  # noqa: E501


        :return: The hour of this InstantType.  # noqa: E501
        :rtype: int
        """
        return self._hour

    @hour.setter
    def hour(self, hour):
        """Sets the hour of this InstantType.


        :param hour: The hour of this InstantType.  # noqa: E501
        :type: int
        """

        self._hour = hour

    @property
    def minute(self):
        """Gets the minute of this InstantType.  # noqa: E501


        :return: The minute of this InstantType.  # noqa: E501
        :rtype: int
        """
        return self._minute

    @minute.setter
    def minute(self, minute):
        """Sets the minute of this InstantType.


        :param minute: The minute of this InstantType.  # noqa: E501
        :type: int
        """

        self._minute = minute

    @property
    def second(self):
        """Gets the second of this InstantType.  # noqa: E501


        :return: The second of this InstantType.  # noqa: E501
        :rtype: int
        """
        return self._second

    @second.setter
    def second(self, second):
        """Sets the second of this InstantType.


        :param second: The second of this InstantType.  # noqa: E501
        :type: int
        """

        self._second = second

    @property
    def nanos(self):
        """Gets the nanos of this InstantType.  # noqa: E501


        :return: The nanos of this InstantType.  # noqa: E501
        :rtype: int
        """
        return self._nanos

    @nanos.setter
    def nanos(self, nanos):
        """Sets the nanos of this InstantType.


        :param nanos: The nanos of this InstantType.  # noqa: E501
        :type: int
        """

        self._nanos = nanos

    @property
    def precision(self):
        """Gets the precision of this InstantType.  # noqa: E501


        :return: The precision of this InstantType.  # noqa: E501
        :rtype: str
        """
        return self._precision

    @precision.setter
    def precision(self, precision):
        """Sets the precision of this InstantType.


        :param precision: The precision of this InstantType.  # noqa: E501
        :type: str
        """
        allowed_values = ["YEAR", "MONTH", "DAY", "MINUTE", "SECOND", "MILLI"]  # noqa: E501
        if precision not in allowed_values:
            raise ValueError(
                "Invalid value for `precision` ({0}), must be one of {1}"  # noqa: E501
                .format(precision, allowed_values)
            )

        self._precision = precision

    @property
    def time_zone(self):
        """Gets the time_zone of this InstantType.  # noqa: E501


        :return: The time_zone of this InstantType.  # noqa: E501
        :rtype: TimeZone
        """
        return self._time_zone

    @time_zone.setter
    def time_zone(self, time_zone):
        """Sets the time_zone of this InstantType.


        :param time_zone: The time_zone of this InstantType.  # noqa: E501
        :type: TimeZone
        """

        self._time_zone = time_zone

    @property
    def value_as_calendar(self):
        """Gets the value_as_calendar of this InstantType.  # noqa: E501


        :return: The value_as_calendar of this InstantType.  # noqa: E501
        :rtype: datetime
        """
        return self._value_as_calendar

    @value_as_calendar.setter
    def value_as_calendar(self, value_as_calendar):
        """Sets the value_as_calendar of this InstantType.


        :param value_as_calendar: The value_as_calendar of this InstantType.  # noqa: E501
        :type: datetime
        """

        self._value_as_calendar = value_as_calendar

    @property
    def time_zone_zulu(self):
        """Gets the time_zone_zulu of this InstantType.  # noqa: E501


        :return: The time_zone_zulu of this InstantType.  # noqa: E501
        :rtype: bool
        """
        return self._time_zone_zulu

    @time_zone_zulu.setter
    def time_zone_zulu(self, time_zone_zulu):
        """Sets the time_zone_zulu of this InstantType.


        :param time_zone_zulu: The time_zone_zulu of this InstantType.  # noqa: E501
        :type: bool
        """

        self._time_zone_zulu = time_zone_zulu

    @property
    def today(self):
        """Gets the today of this InstantType.  # noqa: E501


        :return: The today of this InstantType.  # noqa: E501
        :rtype: bool
        """
        return self._today

    @today.setter
    def today(self, today):
        """Sets the today of this InstantType.


        :param today: The today of this InstantType.  # noqa: E501
        :type: bool
        """

        self._today = today

    @property
    def value_as_string(self):
        """Gets the value_as_string of this InstantType.  # noqa: E501


        :return: The value_as_string of this InstantType.  # noqa: E501
        :rtype: str
        """
        return self._value_as_string

    @value_as_string.setter
    def value_as_string(self, value_as_string):
        """Sets the value_as_string of this InstantType.


        :param value_as_string: The value_as_string of this InstantType.  # noqa: E501
        :type: str
        """

        self._value_as_string = value_as_string

    @property
    def date_time(self):
        """Gets the date_time of this InstantType.  # noqa: E501


        :return: The date_time of this InstantType.  # noqa: E501
        :rtype: bool
        """
        return self._date_time

    @date_time.setter
    def date_time(self, date_time):
        """Sets the date_time of this InstantType.


        :param date_time: The date_time of this InstantType.  # noqa: E501
        :type: bool
        """

        self._date_time = date_time

    @property
    def value(self):
        """Gets the value of this InstantType.  # noqa: E501


        :return: The value of this InstantType.  # noqa: E501
        :rtype: datetime
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this InstantType.


        :param value: The value of this InstantType.  # noqa: E501
        :type: datetime
        """

        self._value = value

    @property
    def primitive(self):
        """Gets the primitive of this InstantType.  # noqa: E501


        :return: The primitive of this InstantType.  # noqa: E501
        :rtype: bool
        """
        return self._primitive

    @primitive.setter
    def primitive(self, primitive):
        """Sets the primitive of this InstantType.


        :param primitive: The primitive of this InstantType.  # noqa: E501
        :type: bool
        """

        self._primitive = primitive

    @property
    def empty(self):
        """Gets the empty of this InstantType.  # noqa: E501


        :return: The empty of this InstantType.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this InstantType.


        :param empty: The empty of this InstantType.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    @property
    def id_element(self):
        """Gets the id_element of this InstantType.  # noqa: E501


        :return: The id_element of this InstantType.  # noqa: E501
        :rtype: StringType
        """
        return self._id_element

    @id_element.setter
    def id_element(self, id_element):
        """Sets the id_element of this InstantType.


        :param id_element: The id_element of this InstantType.  # noqa: E501
        :type: StringType
        """

        self._id_element = id_element

    @property
    def extension_first_rep(self):
        """Gets the extension_first_rep of this InstantType.  # noqa: E501


        :return: The extension_first_rep of this InstantType.  # noqa: E501
        :rtype: Extension
        """
        return self._extension_first_rep

    @extension_first_rep.setter
    def extension_first_rep(self, extension_first_rep):
        """Sets the extension_first_rep of this InstantType.


        :param extension_first_rep: The extension_first_rep of this InstantType.  # noqa: E501
        :type: Extension
        """

        self._extension_first_rep = extension_first_rep

    @property
    def id_base(self):
        """Gets the id_base of this InstantType.  # noqa: E501


        :return: The id_base of this InstantType.  # noqa: E501
        :rtype: str
        """
        return self._id_base

    @id_base.setter
    def id_base(self, id_base):
        """Sets the id_base of this InstantType.


        :param id_base: The id_base of this InstantType.  # noqa: E501
        :type: str
        """

        self._id_base = id_base

    @property
    def resource(self):
        """Gets the resource of this InstantType.  # noqa: E501


        :return: The resource of this InstantType.  # noqa: E501
        :rtype: bool
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this InstantType.


        :param resource: The resource of this InstantType.  # noqa: E501
        :type: bool
        """

        self._resource = resource

    @property
    def boolean_primitive(self):
        """Gets the boolean_primitive of this InstantType.  # noqa: E501


        :return: The boolean_primitive of this InstantType.  # noqa: E501
        :rtype: bool
        """
        return self._boolean_primitive

    @boolean_primitive.setter
    def boolean_primitive(self, boolean_primitive):
        """Sets the boolean_primitive of this InstantType.


        :param boolean_primitive: The boolean_primitive of this InstantType.  # noqa: E501
        :type: bool
        """

        self._boolean_primitive = boolean_primitive

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InstantType):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
